<?php
// CONFIGURATION
// origine sur feuille Kicad
$xOrig=20;
$yOrig=20;
// Taille du PCB
$xSize=265;
$ySize=224;
// distance entre les trous sur MK2 (X et Y identiques)
$dHolesMK2=209;
// Diamètre des trous de fixation
$dHoles=3.2;
// Décalage des trous de fixation par rapport au coin Nord-Ouest du circuit (3 pour le MK2 std)
$xHoleOffset=7.5;
$yHoleOffset=7.5;
// Largeur et espacement des pistes résistives
$rWidth=1.0436;
$rSpacing=0.2;
// Nombre de résistances en parallèle
$nResistors=5;
// Nombre de rangées de pistes par résistance (NOMBRE IMPAIR !)
$nRows=39;
// Largeur des pistes de raccordement
$cWidth=5;

//GÉNÉRATION DU TRACÉ
// Tracé du contour
$xEnd=$xOrig+$xSize;
$yEnd=$yOrig+$ySize;
echo "  (gr_line (start $xOrig $yOrig) (end $xEnd $yOrig) (angle 90) (layer Edge.Cuts) (width 0.15))\n";
echo "  (gr_line (start $xEnd $yOrig) (end $xEnd $yEnd) (angle 90) (layer Edge.Cuts) (width 0.15))\n";
echo "  (gr_line (start $xEnd $yEnd) (end $xOrig $yEnd) (angle 90) (layer Edge.Cuts) (width 0.15))\n";
echo "  (gr_line (start $xOrig $yEnd) (end $xOrig $yOrig) (angle 90) (layer Edge.Cuts) (width 0.15))\n";

// Tracé des trous de fixation
$xHoleOrigPos=$xOrig+$xHoleOffset;
$xHoleEndPos=$xOrig+$xHoleOffset+$dHolesMK2;
$yHoleOrigPos=$yOrig+$yHoleOffset;
$yHoleEndPos=$yOrig+$yHoleOffset+$dHolesMK2;
$yHoleOrig2nd=$yHoleOrigPos+$dHoles/2;
$yHoleEnd2nd=$yHoleEndPos+$dHoles/2;
echo "  (gr_circle (center $xHoleOrigPos $yHoleOrigPos) (end $xHoleOrigPos $yHoleOrig2nd) (layer Edge.Cuts) (width 0.15))\n";
echo "  (gr_circle (center $xHoleOrigPos $yHoleEndPos) (end $xHoleOrigPos $yHoleEnd2nd) (layer Edge.Cuts) (width 0.15))\n";
echo "  (gr_circle (center $xHoleEndPos $yHoleOrigPos) (end $xHoleEndPos $yHoleOrig2nd) (layer Edge.Cuts) (width 0.15))\n";
echo "  (gr_circle (center $xHoleEndPos $yHoleEndPos) (end $xHoleEndPos $yHoleEnd2nd) (layer Edge.Cuts) (width 0.15))\n";

// Tracé du trou de thermistor
$xThPos=$xHoleOrigPos+104.5;
$yThPos=$yHoleOrigPos+104.5;
$yThEnd=$yHoleOrigPos+104.5+1;
echo "  (gr_circle (center $xThPos $yThPos) (end $xThPos $yThEnd) (layer Edge.Cuts) (width 0.15))\n";

// Tracé des pistes résistives
$trackXOrig=$xOrig+$xHoleOffset+4.5;
for ($i = 1; $i <= $nResistors; $i++) {
 for ($j = 1; $j <= $nRows; $j++) {
  $trackXOrig+=$rWidth;
  $trackXOrig+=$rSpacing;
  $trackXEnd=$trackXOrig;
  $trackYOrig=$yOrig+($ySize-200)/2;
  $trackYEnd=$yEnd-($ySize-200)/2;
  if ($j==1){$trackYOrig=$trackYOrig-2-$cWidth/2;}
  if ($j==$nRows){$trackYEnd=$trackYEnd+2+$cWidth/2;}
  echo "  (segment (start $trackXOrig $trackYOrig) (end $trackXEnd $trackYEnd) (width 1.1) (layer B.Cu) (net 0))\n";
// Tracé liaisons entre pistes
  $xLinkPos=$trackXOrig+$rWidth+$rSpacing;
  if ($j!=$nRows){
   if ($j % 2){echo "  (segment (start $trackXOrig $trackYEnd) (end $xLinkPos $trackYEnd) (width 1.1) (layer B.Cu) (net 0))\n";}
   else{echo "  (segment (start $trackXOrig $trackYOrig) (end $xLinkPos $trackYOrig) (width 1.1) (layer B.Cu) (net 0))\n";}
  }
 }
}
?>